module AplConstants

  #BU
  module BU
    WSR        = 'wsr'
    FKI        = 'fki'
    FKMP       = 'fkmp'
    EKL        = 'ekl'
    INFRA      = 'infra'
    NEXT_WSR   = 'next_wsr'
    NEXT_EKL   = 'next_ekl'
    NEXT_FKMP  = 'next_fkmp'
    INVALID_BU = 'invalid_bu'
  end

  #OTHER CONSTANTS
  TENANT = 'X_BU_ID'

  module Accruals
    module Type
      COST    = ['cost_accrual','cost_reversal_accrual']
      REVENUE = ['revenue_accrual','revenue_reversal_accrual']
    end

    module ItemType
      SERVICE = 'ServiceAccrualItem'
      TAX     = 'TaxAccrualItem'
    end

    module ItemTypeInRequest
      SERVICE = 'Service'
      TAX     = 'Tax'
    end
  end

  module Invoice
    INVOICE   = 'invoice'

    module Type
      COST_INVOICE        = 'cost_invoice'
      REVENUE_INVOICE     = 'revenue_invoice'
      DUMMY_INVOICE       = 'dummy_invoice'
      VENDOR_CREDIT_NOTE  = 'vendor_credit_note'
      VENDOR_DEBIT_NOTE   = 'vendor_debit_note'
      REVENUE_DEBIT_NOTE  = 'revenue_debit_note'
      REVENUE_CREDIT_NOTE = 'revenue_credit_note'
    end

    module ItemType
      PRODUCT        = 'ProductInvoiceItem'
      FEATURE        = 'FeatureInvoiceItem'
      SERVICE        = 'ServiceInvoiceItem'
      TAX            = 'TaxInvoiceItem'
      DISCOUNT       = 'DiscountInvoiceItem'
      MISCELLANEOUS  = 'MiscellaneousInvoiceItem'
    end

    module ItemTypeInRequest
      SERVICE    = 'Service'
      TAX        = 'Tax'
    end
  end

  module GL
    ACCOUNTING_TRANSACTION = 'accounting_transaction'

    module Accounts
      LEDGER_ACCOUNT            = 'ledger_account'
      NATURAL_ACCOUNT           = 'natural_account'
      DEPARTMENT                = 'department'
      LOCATION                  = 'location'
      PRODUCT_CATEGORY          = 'product_category'
    end
  end

end