module AplFieldPadder

  TYPE_VAL_NUM_SLOTS = 4
  BU_ID_NUM_SLOTS = 6

  PADDING_CHAR = '*'

  def get_padded_type type_val
    return get_padded_value(type_val, TYPE_VAL_NUM_SLOTS)
  end

  def get_padded_bu bu_id_val
    return get_padded_value(bu_id_val, BU_ID_NUM_SLOTS)
  end

  private

  def get_padded_value(field_val, num_slot_for_field)
    default_string =  PADDING_CHAR*num_slot_for_field
    return default_string if field_val.blank?

    padded_field_val = default_string.sub(PADDING_CHAR*field_val.size, field_val)
    padded_field_val
  end

end