module DecimalMatcher
  class BeDecimal
    def initialize(expected)
      @expected = BigDecimal.new(expected)
    end

    def matches?(target)
      @target = target
      @target.is_a?(BigDecimal) && @target == @expected
    end

    def failure_message_for_should
      "expected #{@target.inspect} to be a [BigDecimal: #{@expected.to_s("F")}]"
    end

    def failure_message_for_should_not
      "expected #{@target.inspect} not to be a [BigDecimal: #{@expected.to_s("F")}]"
    end
  end

  def be_decimal(expected)
    BeDecimal.new(expected)
  end
end
