require 'sc_core/errors/supply_chain_error_codes'

module ActiveModel

  class ErrorMessage < String

    attr_accessor :code, :message

    def initialize(code , message)
      @code , @message = code , message
      super message
    end

  end

  class Errors

    def add(attribute, message = nil, options = {})
      message ||= :invalid
      code = SupplyChainErrorCodes::ArMapping[message]
      if message.is_a?(Symbol)
        message = generate_message(attribute, message, options.except(*CALLBACKS_OPTIONS))
      elsif message.is_a?(Proc)
        message = message.call
      end
      self[attribute] << ErrorMessage.new(code , message)
    end

  end

end