PADRINO_ENV ||= ENV["PADRINO_ENV"] || ENV["RAILS_ENV"]
LOCALHOST = "localhost"
DEPLOY_ENV = (ENV["DEPLOY_ENV"] || (Object.const_defined?('DEPLOY_ENV') && DEPLOY_ENV) || LOCALHOST)
SUPPLY_CHAIN_ENV = PADRINO_ENV
SUPPLY_CHAIN_COMPANY ||= ENV["SUPPLY_CHAIN_COMPANY"]
DEPLOY_DOMAIN = ENV["DEPLOY_DOMAIN"] || ".nm.flipkart.com"
FLO_CONFIG = ENV["FLO_CONFIG"] || "/etc/flo/env_config.rb"
DB_USER = "root"
DB_PASSWORD = ""

require 'pp'

class SupplyChain
  def self.require_if_exists(path)
    require path if File.exists? path
  end

  def self.localhost?
    DEPLOY_ENV == LOCALHOST
  end

  if localhost?
    require_if_exists "#{ENV['HOME']}/.flo/env_config.rb"
  else
    require_if_exists FLO_CONFIG
  end

  @@urls = nil

  SERVICES = {
      :oms => {:b2c => 35001, :b2b => 36001, :system_user => 'sc_oms', :system_pass => 'Y6XoQTrN'},
      :customer => {:b2c => 3101, :b2b => 4101, :system_user => 'sc_customer', :system_pass => 'Y6XoQTrN'},
      :payment => {:b2c => 35021, :b2b => 36021, :system_user => 'sc_payment', :system_pass => 'Y6XoQTrN'},
      :fulfillment => {:b2c => 35041, :b2b => 36041, :system_user => 'sc_fulfillment', :system_pass => 'Y6XoQTrN'},
      :proc => {:b2c => 35061, :b2b => 36061, :system_user => 'sc_proc', :system_pass => 'Y6XoQTrN'},
      :warehouse => {:b2c => 35081, :b2b => 36081, :system_user => 'sc_warehouse', :system_pass => 'Y6XoQTrN'},
      :doc => {:b2c => 35101, :b2b => 36101, :system_user => 'sc_doc', :system_pass => 'Y6XoQTrN'},
      :geocourier => {:b2c => 35121, :b2b => 36121, :system_user => 'sc_geocourier', :system_pass => 'Y6XoQTrN'},
      :nss => {:b2c => 35141, :b2b => 36141, :system_user => 'sc_nss', :system_pass => 'Y6XoQTrN'},
      :supplier => {:b2c => 35161, :b2b => 36161, :system_user => 'sc_supplier', :system_pass => 'Y6XoQTrN'},
      :demo => {:b2c => 8001, :b2b => 9001, :system_user => 'sc_demoproject', :system_pass => 'Y6XoQTrN'},
      :omsui => {:b2c => 35000, :b2b => 36000, :system_user => 'sc_omsui', :system_pass => 'Y6XoQTrN'},
      :warehouseui => {:b2c => 35080, :b2b => 36080, :system_user => 'sc_warehouseui', :system_pass => 'Y6XoQTrN'},
      :procui => {:b2c => 35060, :b2b => 36060, :system_user => 'sc_procui', :system_pass => 'Y6XoQTrN'},
      :authui => {:b2c => 35180, :b2b => 36180, :system_user => 'sc_authui', :system_pass => 'Y6XoQTrN'},
      :accountingui => {:b2c => 35020, :b2b => 36020, :system_user => 'sc_accountingui', :system_pass => 'Y6XoQTrN'},
      :demoui => {:b2c => 8000, :b2b => 9000, :system_user => 'sc_demoui', :system_pass => 'Y6XoQTrN'},
      :shippingui => {:b2c => 27780, :b2b => 27780, :system_user => 'fkl_shippingui', :system_pass => 'Y6XoQTrN', :relative_url => 'fklshipping'},
      :merchant => {:b2c => 27700, :b2b => 27700, :system_user => 'fkl_merchant', :system_pass => 'Y6XoQTrN'},
      :vendor => {:b2c => 27720, :b2b => 27720, :system_user => 'fkl_vendor', :system_pass => 'Y6XoQTrN'},
      :logistics => {:b2c => 27760, :b2b => 27760, :system_user => 'fkl_logistics', :system_pass => 'Y6XoQTrN'},
      :shipping => {:b2c => 27740, :b2b => 27740, :system_user => 'fkl_shipping', :system_pass => 'Y6XoQTrN'},
      :console => {:b2c => 35190, :b2b => 35190, :system_user => 'sc_console', :system_pass => 'Y6XoQTrN'}
  }

  CAS_CALLBACK_SERVICE_PORTS = {
      :oms => {:b2c => 35003, :b2b => 36003},
      :customer => {:b2c => 3103, :b2b => 4103},
      :payment => {:b2c => 35023, :b2b => 36023},
      :fulfillment => {:b2c => 35043, :b2b => 36043},
      :proc => {:b2c => 35063, :b2b => 36063},
      :warehouse => {:b2c => 35083, :b2b => 36083},
      :shipping => {:b2c => 3603, :b2b => 4603},
      :doc => {:b2c => 35103, :b2b => 36103},
      :geocourier => {:b2c => 35123, :b2b => 36123},
      :nss => {:b2c => 35143, :b2b => 36143},
      :supplier => {:b2c => 35163, :b2b => 36163},
      :demo => {:b2c => 8003, :b2b => 9003},
      :omsui => {:b2c => 35002, :b2b => 36002},
      :warehouseui => {:b2c => 35082, :b2b => 36082},
      :procui => {:b2c => 35062, :b2b => 36062},
      :authui => {:b2c => 35182, :b2b => 36182},
      :accountingui => {:b2c => 35022, :b2b => 36022},
      :demoui => {:b2c => 8002, :b2b => 9002},
      :shippingui => {:b2c => 27783, :b2b => 27783},
      :merchant => {:b2c => 27703, :b2b => 27703},
      :vendor => {:b2c => 27723, :b2b => 27723},
      :logistics => {:b2c => 27763, :b2b => 27763},
      :shipping => {:b2c => 27743, :b2b => 27743},
      :console => {:b2c => 35192, :b2b => 35192}
  }

  
  # FIXME: Use the the SERVICES urls instead 
  FKL_PORTS = {
    :geo_courier => 27720,
    :fkl_shipping => 27740
  }

  class << self
    def db_config_key(is_slave)
      db_config_key = is_slave ? 'slave_db' : 'db'
    end

    def db_host(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY, is_slave=false)
      # e.g. staging.b2c.oms.db.flipkart.com
      #"#{resource_env}-#{SUPPLY_CHAIN_COMPANY}-#{SERVICE_NAME}.db.nm.flipkart.com"
      config = get_config_values
      db_host = LOCALHOST if localhost?
      db_host = config[service_name.to_sym]["#{company}_#{db_config_key(is_slave)}_host".to_sym] if config[service_name.to_sym]
      db_host = "#{resource_env}-#{company}-#{service_name}-#{db_config_key(is_slave)}#{DEPLOY_DOMAIN}" unless db_host
      db_host
    end

    def db_user(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY, is_slave=false)
      config = get_config_values
      db_user = config[service_name.to_sym]["#{company}_#{db_config_key(is_slave)}_user".to_sym] if config[service_name.to_sym]
      db_user = DB_USER unless db_user
      db_user
    end

    def db_password(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY, is_slave=false)
      config = get_config_values
      db_password = config[service_name.to_sym]["#{company}_#{db_config_key(is_slave)}_password".to_sym] if config[service_name.to_sym]
      db_password = DB_PASSWORD unless db_password
      db_password
    end

    def slave_db_host(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      db_host(service_name, company, true)
    end

    def slave_db_user(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      db_user(service_name, company, true)
    end

    def slave_db_password(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      db_password(service_name, company, true)
    end

    def db_name(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      # e.g. oms_b2c_development if DEPLOY_ENV=locahost
      # e.g oms_b2c_staging if DEPLOY_ENV=staging
      "#{service_name}_#{company}_#{resource_env}"
    end
    
    alias_method :slave_db_name, :db_name
    
    def statsd_namespace(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      "#{service_name}_#{company}_#{resource_env}"
    end

    def mq_host(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      #"#{resource_env}-#{SUPPLY_CHAIN_COMPANY}-#{SERVICE_NAME}-mq.nm.flipkart.com"
      config = get_config_values
      mq_host = LOCALHOST if localhost?
      mq_host = config[service_name.to_sym]["#{company}_mq_host".to_sym] if config[service_name.to_sym]
      mq_host = "#{resource_env}-#{company}-#{service_name}-mq#{DEPLOY_DOMAIN}" unless mq_host
      mq_host
    end

    def app_id(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      "#{service_name}_#{company}_#{resource_env}"
    end

    def queue_name(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      "#{service_name}_#{company}_#{resource_env}"
    end

    def exchange_name(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      queue_name(service_name, company)
    end

    def topic_exchange_name(company=SUPPLY_CHAIN_COMPANY)
      "pubsub_#{company}_#{resource_env}.topic.exchange"
    end

    def topic_queue_name(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      "#{service_name}_#{company}_#{resource_env}.topic.queue"
    end

    def sideline_queue_name(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      "#{service_name}_#{company}_#{resource_env}.sideline.fanout.queue"
    end

    def sideline_exchange_name(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      "#{service_name}_#{company}_#{resource_env}.sideline.fanout.exchange"
    end

    def service_name_with_company
      @service_name_with_company ||=
        begin
          full_service_name = ""
          full_service_name << SERVICE_NAME if defined?(SERVICE_NAME)
          full_service_name << "-#{SUPPLY_CHAIN_COMPANY}" if defined?(SUPPLY_CHAIN_COMPANY)
          full_service_name
        end
    end

    def url
      urls["#{SERVICE_NAME}_url"]
    end

    def restbus_url
      config = get_config_values
      config[:restbus_url]
    end

    def cas_callback_url
      config = get_config_values
      callback_url = "https://#{LOCALHOST}:#{CAS_CALLBACK_SERVICE_PORTS[SERVICE_NAME.to_sym][SUPPLY_CHAIN_COMPANY.to_sym]}/cas_proxy_callback/receive_pgt" if localhost?

      if config[SERVICE_NAME.to_sym] && config[SERVICE_NAME.to_sym][SUPPLY_CHAIN_COMPANY.to_sym]
        callback_url = "https://#{config[SERVICE_NAME.to_sym][SUPPLY_CHAIN_COMPANY.to_sym]}:#{CAS_CALLBACK_SERVICE_PORTS[SERVICE_NAME.to_sym][SUPPLY_CHAIN_COMPANY.to_sym]}/cas_proxy_callback/receive_pgt"
        callback_url = "https://#{config[SERVICE_NAME.to_sym][SUPPLY_CHAIN_COMPANY.to_sym]}:#{config[SERVICE_NAME.to_sym]["#{SUPPLY_CHAIN_COMPANY}_cas_port".to_sym]}/cas_proxy_callback/receive_pgt"  if config[SERVICE_NAME.to_sym]["#{SUPPLY_CHAIN_COMPANY}_cas_port".to_sym]
        # If the service has a relative url append it before '/cas_proxy_callback/receive_pgt'
        callback_url.gsub!("/cas_proxy_callback/receive_pgt", "/#{config[SERVICE_NAME.to_sym][:relative_url]}/cas_proxy_callback/receive_pgt") if config[SERVICE_NAME.to_sym][:relative_url]
      end

      callback_url = "https://#{resource_env}-#{SUPPLY_CHAIN_COMPANY}-#{SERVICE_NAME}#{DEPLOY_DOMAIN}:#{CAS_CALLBACK_SERVICE_PORTS[SERVICE_NAME.to_sym][SUPPLY_CHAIN_COMPANY.to_sym]}/cas_proxy_callback/receive_pgt" unless callback_url
      callback_url
    end

    def cas_url
      config = get_config_values
      cas_url = "https://#{LOCALHOST}:8443" if localhost?
      if config[:cas]
        cas_url = "https://#{config[:cas][SUPPLY_CHAIN_COMPANY.to_sym]}:8443"
        cas_url = "https://#{config[:cas][SUPPLY_CHAIN_COMPANY.to_sym]}:#{config[:cas]["#{SUPPLY_CHAIN_COMPANY}_port".to_sym]}" if config[:cas]["#{SUPPLY_CHAIN_COMPANY}_port".to_sym]
      end
      cas_url = "https://#{resource_env}-#{SUPPLY_CHAIN_COMPANY}-cas#{DEPLOY_DOMAIN}:8443" unless cas_url
      cas_url
    end

    def digital_url
      config = get_config_values
      config[:digital][SUPPLY_CHAIN_COMPANY.to_sym] || config[:digital][:b2c]
    end

    def user_service_url
      config = get_config_values
      config[:user_service]
    end

    def amayo_url
      config = get_config_values
      config[:amayo_service]
    end

    def cms_service_url
      config = get_config_values
      config[:cms_service] ? config[:cms_service] : 'stage-cms-app2.nm.flipkart.com'
    end
    
    def sss_service_host
      config = get_config_values
      config[:sss_service] ? config[:sss_service] : 'stage-cms-app1.nm.flipkart.com'
    end

    def sss_service_port
      get_config_values[:sss_service_port] || 26401
    end

    def vendor_master_host
      get_config_values[:vendor_master_host] || "stage-fko-app1.nm.flipkart.com"
    end

    def vendor_master_port
      get_config_values[:vendor_master_port] || 27307
    end

    def w3_service_url
      get_config_values[:w3_service_url] || "http://stage-sherlock1.nm.flipkart.com:25280/sherlock/stores/flipkart.com/select"
    end

    def w3_product_service_url
      get_config_values[:w3_product_service] || "http://stage-web1.nm.flipkart.com/InternalApi/ProductService/getProductSummaryInfo"
    end

    def oms_splitter_url
      get_config_values[:oms_splitter_url] || "http://stage-oms-app1.nm.flipkart.com:27401/fk-erp-oms/admin/"
    end

    def ldap_connection_settings
      config = get_config_values
      return config[:ldap_settings] if config[:ldap_settings].present?
      {'host' => 'rearch-ldap.corp.flipkart.com', 'port'=> 636, 'base'=> 'dc=flipkart,dc=com', 'method'=> :ssl, 'bind_dn' => 'cn=admin,dc=flipkart,dc=com', 'password' => 'flipkart'}
    end

    def statsd_connection_settings
      config = get_config_values
      statsd_settings = config[:statsd]
      return 'localhost', 8125 unless statsd_settings.present?
      return (statsd_settings[:host] || 'localhost'), (statsd_settings[:port] || 8125)
    end

    def communication_service_settings
      config = get_config_values
      return config[:communication_service_settings] if config[:communication_service_settings].present?
      {'host' => 'sb-node1.nm.flipkart.com', 'port'=> 25352}
    end

    def system_user(service_name = SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      config = get_config_values
      user_key = "#{service_name}_#{company}".to_sym
      username = config[service_name.to_sym][user_key] if config[service_name.to_sym]
      return username if username

      "#{SERVICES[service_name.to_sym][:system_user]}_#{company}"
    end

    def system_pass(service_name = SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      config = get_config_values
      password_key = "#{service_name}_#{company}".to_sym
      password = config[service_name.to_sym][password_key] if config[service_name.to_sym]
      return password if password

      SERVICES[service_name.to_sym][:system_pass]
    end

    def job_scheduler_url
      config = get_config_values
      if config[:jobschedular_url]
        return config[:jobschedular_url]
      elsif config[:jobsch]
        job_sc_url = "http://#{config[:jobsch][SUPPLY_CHAIN_COMPANY.to_sym]}:4444" 
      else
        job_sc_url = "http://#{LOCALHOST}:4444" if localhost?
        job_sc_url = "http://#{resource_env}-#{SUPPLY_CHAIN_COMPANY}-jobsch#{DEPLOY_DOMAIN}:4444" unless job_sc_url
      end
      job_sc_url
    end

    # FIXME use SERVICES url instead
    def geo_courier_url
      config = get_config_values
      if config[:geo_courier_url]
        return config[:geo_courier_url]
      elsif config[:geo_courier]
        geo_c_url = "http://#{config[:geo_courier][SUPPLY_CHAIN_COMPANY.to_sym]}:#{FKL_PORTS[:geo_courier]}"
      else
        geo_c_url = "http://#{LOCALHOST}:#{FKL_PORTS[:geo_courier]}" if localhost?
        geo_c_url = "http://#{resource_env}-#{SUPPLY_CHAIN_COMPANY}-geocourier#{DEPLOY_DOMAIN}:#{FKL_PORTS[:geo_courier]}" unless geo_c_url
      end
      geo_c_url
    end

    alias_method :vendor_url, :geo_courier_url

    # FIXME use SERVICES url instead
    def fkl_shipping_url
      config = get_config_values
      if config[:fkl_shipping_url]
        return config[:fkl_shipping_url]
      elsif config[:fkl_shipping]
        fkl_s_url = "http://#{config[:fkl_shipping][SUPPLY_CHAIN_COMPANY.to_sym]}:#{FKL_PORTS[:fkl_shipping]}"
      else
        fkl_s_url = "http://#{LOCALHOST}:#{FKL_PORTS[:fkl_shipping]}" if localhost?
        fkl_s_url = "http://#{resource_env}-#{SUPPLY_CHAIN_COMPANY}-fklshipping#{DEPLOY_DOMAIN}:#{FKL_PORTS[:fkl_shipping]}" unless fkl_s_url
      end
      fkl_s_url
    end

    def cache_config
      config = get_config_values
      if config[:cache].nil?
        raise 'Missing :cache config in flo/env_config.rb'
      end
      defaults = {:urls => nil, :bucket => cache_bucket, :username => cache_bucket, :password => "", :namespace => ""}
      config[:cache].delete(:bucket) # ignore bucket if set in config
      defaults.merge config[:cache]
    end

    def cache_bucket(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      "flo_#{service_name}_#{company}_#{resource_env}"
    end

    def cache_namespace(service_name=SERVICE_NAME, company=SUPPLY_CHAIN_COMPANY)
      ''
    end

    def urls
      config = get_config_values
      if @@urls == nil
        @@urls = {}

        SERVICES.keys.each do |service|
          if localhost?
            @@urls["#{service}_b2b_url"] = "http://#{LOCALHOST}:#{SERVICES[service][:b2b]}"
            @@urls["#{service}_b2c_url"] = "http://#{LOCALHOST}:#{SERVICES[service][:b2c]}"
            @@urls["#{service}_url"] = "http://#{LOCALHOST}:#{SERVICES[service][SUPPLY_CHAIN_COMPANY.to_sym]}"
          end

          if config[service]
            @@urls["#{service}_b2b_url"] = "http://#{config[service][:b2b]}:#{SERVICES[service][:b2b]}" if config[service][:b2b]
            @@urls["#{service}_b2c_url"] = "http://#{config[service][:b2c]}:#{SERVICES[service][:b2c]}" if config[service][:b2c]
            @@urls["#{service}_url"] = "http://#{config[service][SUPPLY_CHAIN_COMPANY.to_sym]}:#{SERVICES[service][SUPPLY_CHAIN_COMPANY.to_sym]}" if config[service][SUPPLY_CHAIN_COMPANY.to_sym]

            @@urls["#{service}_b2b_url"] = "http://#{config[service][:b2b]}:#{config[service]["b2b_port".to_sym]}" if config[service]["b2b_port".to_sym]
            @@urls["#{service}_b2c_url"] = "http://#{config[service][:b2c]}:#{config[service]["b2c_port".to_sym]}" if config[service]["b2c_port".to_sym]
            @@urls["#{service}_url"] = "http://#{config[service][SUPPLY_CHAIN_COMPANY.to_sym]}:#{config[service]["#{SUPPLY_CHAIN_COMPANY}_port".to_sym]}" if config[service]["#{SUPPLY_CHAIN_COMPANY}_port".to_sym]

            # If relative root url is defined for the service, append it to to the urls
            [@@urls["#{service}_b2b_url"], @@urls["#{service}_b2c_url"], @@urls["#{service}_url"]].collect! { |service_url| service_url << "/#{config[service][:relative_url]}" if config[service][:relative_url]}

          end

          @@urls["#{service}_b2b_url"] = "http://#{resource_env}-b2b-#{service}#{DEPLOY_DOMAIN}:#{SERVICES[service][:b2b]}" unless @@urls["#{service}_b2b_url"]
          @@urls["#{service}_b2c_url"] = "http://#{resource_env}-b2c-#{service}#{DEPLOY_DOMAIN}:#{SERVICES[service][:b2c]}" unless @@urls["#{service}_b2c_url"]
          @@urls["#{service}_url"] = "http://#{resource_env}-#{SUPPLY_CHAIN_COMPANY}-#{service}#{DEPLOY_DOMAIN}:#{SERVICES[service][SUPPLY_CHAIN_COMPANY.to_sym]}" unless @@urls["#{service}_url"]

        end
      end
      @@urls

    end

    def get_config_values
      config = defined?(FloConfig) && FloConfig::CONFIG[DEPLOY_ENV.to_sym] && FloConfig::CONFIG[DEPLOY_ENV.to_sym][SUPPLY_CHAIN_ENV.to_sym]
      if !config
        return {} if localhost?
        raise "Configuration for DEPLOY_ENV[#{DEPLOY_ENV}] and SUPPLY_CHAIN_ENV[#{SUPPLY_CHAIN_ENV}] not found "
      end
      config
    end

    def resource_env
      (localhost? && SUPPLY_CHAIN_ENV) || DEPLOY_ENV
    end

    def url_has_port?(url)
      url.count(':') != 0
    end
  end

end
