require File.expand_path(File.dirname(__FILE__)) +"/../clients/platform_queue_client"

module PlatformQueueHelper

  #Wait for minimum number of min_message_count to appear in queue for max_time
  def self.wait_for_minimum_messages_to_populate_in_queue(platform_queue_client, queue_name, min_message_count, max_time)
    granular_sleep = 0.5
    total_sleep = 0
    while JSON.parse(platform_queue_client.get_messages(queue_name, min_message_count).body).size < min_message_count
      sleep granular_sleep
      total_sleep +=  granular_sleep
      p "Total Time #{total_sleep}"
      break if total_sleep >= max_time
    end
    return JSON.parse(platform_queue_client.get_messages(queue_name, min_message_count).body).size >= min_message_count
  end

  #Would wait till messages come down to max number or return false
  def self.wait_for_maximum_messages_to_populate_in_queue(platform_queue_client, queue_name, max_message_count, max_time)
    granular_sleep = 0.5
    total_sleep = 0
    while JSON.parse(platform_queue_client.get_messages(queue_name, 10000).body).size > max_message_count
      sleep granular_sleep
      total_sleep +=  granular_sleep
      p "Total Time #{total_sleep}"
      break if total_sleep >= max_time
    end
    return JSON.parse(platform_queue_client.get_messages(queue_name, min_message_count).body).size <= max_message_count
  end
end
