require_relative '../../lib/apl-library/recursive_open_struct.rb'

class RecursiveOpenStructTest < BaseModelTest
  include RecursiveOpenStruct

  context 'open struct' do
    setup do
      @invoice = {
          'id' => 'ci20130400000934',
          'invoice_date' => '2013-04-01',
          'party_id_from' => 'flipkart_india',
          'party_id_to' => 'wsretail',
          'product_items' =>
              {
                  'product_category_id' => '20210',
                  'discount_items' => [],
                  'tax_items' => [],
                  'total_amount' => '31271.66'
              },
          'total_amount' => '31271.66'
      }
    end

    should 'verify recursive object creation' do
      obj_inv = build_open_struct @invoice
      assert_equal OpenStruct, obj_inv.class
      assert_equal OpenStruct, obj_inv.product_items.class
    end
  end
end
