require File.expand_path(File.dirname(__FILE__) + '/../clients/sc_client.rb')
module SC
  module Utils
    module TestFunctions
      include ScLibrary

      #First Error message in case you have multiple error messages
      #expected_message can be directly a regex also
      def validate_error_message(json_error_res_messages, expected_type, expected_code, expected_params_map,expected_message)
#        messages = JSON.parse(json_error_res_messages.body)["messages"]
        messages = JSON.parse(json_error_res_messages)["messages"]

        messages.each do |observed_message|
          message_matched = (expected_message == observed_message["message"])
          (message_matched = observed_message["message"] =~ expected_message) if expected_message.instance_of?(Regexp)

          return if expected_type == observed_message["type"] and
              expected_code == observed_message["code"] and
              expected_params_map == observed_message["params"] and message_matched

        end

        assert_equal(true,false,"Expected Error Message with type = '#{expected_type}' code = '#{expected_code}' params '#{expected_params_map}' and message = '#{expected_message}' not found in observed error messages '#{json_error_res_messages}'")
      rescue JSON::ParserError
        fail"Error Response body '#{json_error_res_messages.body}' is not proper json"
      end

      # Validates 2 levels of json bodies.
      #Useful when expected json has lesser params then json_response. Otherwise make use of assert_equal
      def validate_json_bodies(expected_json, json_response)
        puts "Matching Json"
        result  = JSON.validate_json_bodies(expected_json, json_response)
        assert_equal(true, result[:pass], result[:message])
      end

=begin
        def validate_message_in_platform_queue(platform_queue_client, queue_name, expected_uri, expected_http_method, expected_payload, among_last_messages=1)
          messages  = JSON.parse(platform_queue_client.get_messages(queue_name,among_last_messages))
          messages.each do |message|
            observed_payload    = message["payload"]
            observed_http_method  = message["properties"]["headers"]["http_method"]
            observed_http_url   = message["properties"]["headers"]["http_uri"]

            return if expected_uri == observed_http_url and
                expected_payload.to_json == observed_payload and expected_http_method == observed_http_method
          end
          assert_true(false,"Message with http_uri #{expected_uri} payload #{expected_payload} and http method #{expected_http_method} not found in observed messages #{messages}")
        end
=end

      #Request Sample : rest_response,"Picklist","id","non_existent_value"
      def validate_non_found_http_response(resp_response, resource_name, resource_value_name, non_existent_resource_value)
        assert_equal(ScClient::STATUS_NOT_FOUND, resp_response.code, "Status Code")

        validate_error_message(resp_response.body,
                               "ERROR",
                               "SC_NOT_FOUND",
                               {}, # regex - should start with 'Couldn't find .....' , this handles messages with where clause as well.
                               Regexp.new("\\ACouldn't find #{resource_name} with #{resource_value_name}=#{non_existent_resource_value}"))

      end

      def validate_error_response_for_missing_param_in_request(rest_response,missing_param, value =nil, message= "#{missing_param} is mandatory")
        assert_equal(ScClient::STATUS_BAD_REQUEST,rest_response.code,"Status Code")
        validate_error_message(rest_response.body,
                               "ERROR",
                               "SC_BLANK",
                               {"field" => missing_param.to_s, "value" => value},
                               message)
      end

      def validate_error_message_for_non_positive_field_in_request(rest_response, field, quantity)
        assert_equal(ScClient::STATUS_BAD_REQUEST,rest_response.code,"Status Code")
        validate_error_message(rest_response.body,
                               "ERROR",
                               "SC_GREATER_THAN_OR_EQUAL_TO",
                               {"field"=> field.to_s,"value" => quantity},
                               "#{field.to_s} should be a positive integer.")
      end
    end
  end
end
