require File.expand_path(File.dirname(__FILE__) + '/../constants/http_status_codes.rb')
#Mixin of WarehouseOperations requires
#   : warehouse_client function implementation in the class which is mixin WarehouseOperations
#   : shelves function to return hash of shelf hashies
require 'json'
require_relative "../../../lib/sc-test-core/utils/hash_extension"
require 'hashie'
module SC
  module Validations
    module OMSValidations
      include SC::Constants::HttpStatusCodes

      #order_items_params = [{:fsn=>fsn, :sku=>sku, quantity=> quantity ....}]
      #order_params = {:status=>status, :amount => 100 ....}
      def validate_order(order_id, order_params, order_items_params = nil)
        response = oms_client.getOrderById(order_id)
        order_json = JSON(response.body)
        puts "order json #{order_json}"
        assert_true(order_json.has_hash?(JSON(order_params.to_json)), "Order #{order_json} doesn't have matching params #{order_params}'")

        observed_order_items = order_json["order_items"]
        all_items_found = true

        order_items_params = [] if order_items_params.nil?
        order_items_params.each do |order_item_params|
          item_found = false
          observed_order_items.each do |observed_order_item|
            if observed_order_item.has_hash? JSON(order_item_params.to_json)
              item_found = true
              break
            end
            all_items_found &= item_found
          end
        end

        assert_true(all_items_found, "Order #{order_json} doesn't have matching order items params #{order_items_params}'")
        puts "Order id #{order_id} has order params #{order_params} and order items params #{order_items_params}"
      end

      #order_items_params = [{:product_id=>fsn, :sku=>sku, quantity=> quantity ....}]
      #order_params = {:status=>status, :amount => 100 ....}
      def order_exists(order_params, order_items_params)
        response = oms_client.findOrders
        response_json = JSON(response.body)

        assert(response_json["total"] > 0, "Zero Orders found")

        observed_orders = response_json["orders"]
        observed_orders.each do |order_json|

          if order_json.has_hash? JSON(order_params.to_json)
            puts "Order with params #{order_params} is found. Checking on required order_items"

            observed_order_items = order_json["order_items"]
            all_items_found = true
            order_items_params.each do |order_item_params|
              item_found = false
              observed_order_items.each do |observed_order_item|
                if observed_order_item.has_hash? JSON(order_item_params.to_json)
                  item_found = true
                  break
                end
                all_items_found &= item_found
              end
            end

            if(all_items_found)
              puts "Order with params #{order_params} and order items params #{order_items_params} found"
              order = Hashie::Mash.new(order_json)
              order_item_ids = order_json["order_items"].collect {|order_item_json| order_item_json["id"]}
              return order, order_item_ids
            end

          end
        end
        assert(false, "Order with params #{order_params} and items #{order_items_params} not found in observed orders #{observed_orders}")

      end

    end
  end
end