require 'benchmark'

class ScMetrics::MethodProfiler
  attr_reader :object

  def initialize(object)
    @object = object
  end

  def method_missing(method_name, *args, &block)
    result = nil
    time_elapsed = Benchmark.realtime do
      result = object.send(method_name.to_sym, *args, &block)
    end

    key = "method_profiler.#{object.class}.#{method_name}".gsub(/::/, '_').gsub(/:/, '_')
    ScMetrics.timing(key, (time_elapsed*1000).to_i)
    result
  end
end
