require_relative "statsd_client"
require 'active_support/core_ext/module/delegation.rb'

class ScMetrics
  class << self
    def client
      unless Thread.current[:statsd_client]
        statsd = Statsd.new(*SupplyChain.statsd_connection_settings)
        statsd.namespace = SupplyChain::statsd_namespace
        statsd.increment "init_statsd_client.count"
        Thread.current[:statsd_client] = statsd
      end
      Thread.current[:statsd_client]
    end

    def increment(metric_name, value=1)
      client.increment("#{metric_name}.count", value)
    end
    def decrement(metric_name, value=1)
      client.decrement("#{metric_name}.count", value)
    end
    def count(metric_name,value)
      client.count("#{metric_name}.count",value)
    end

    delegate :gauge, :timing, :time, :to => :client
  end
end
