#require "mysql2"
module ScLibrary

  class ScSqlHelper

    attr_reader :connection

    def create_connection connection_string
      begin
        @connection = Mysql2::Client.new(:host => connection_string[:host],:username => connection_string[:username],:password =>connection_string[:password],:database => connection_string[:db])
      end
    end

    def close_connection
      @connection.close if @connection
    end

    def execute_query(sql)
      begin
        @connection.query sql
      rescue Mysql2::Error => e
        @connection.close
        raise Mysql2::Error, e.error
      end
    end

    def delete_table(table_name,condition=nil)
      query = "delete from #{table_name}"
      query = query +" where #{condition}" if not condition.nil? and condition!=""
      execute_query(query)
    end

    def execute_and_return_in_array(sql)
      execute_and_map_result sql do |result_set| result_set.each(:as => :array) end
    end

    def execute_and_return_in_hash(sql)
      execute_and_map_result sql do |result_set| result_set.each(:symbolize_keys => false) end
    end


    def execute_prepared_statement(sql)
      begin
        statement = @connection.prepare(sql)
        statement.execute
      end
    end

    private
    def execute_and_map_result(sql,&row_fetcher)
      result_set = self.execute_query sql
      begin
        return row_fetcher.call(result_set)
      end
    end
  end
end
