require File.expand_path(File.dirname(__FILE__) + '/../constants/http_status_codes.rb')
#Mixin of WarehouseOperations requires
#   : warehouse_client function implementation in the class which is mixin WarehouseOperations
#   : shelves function to return hash of shelf hashies
require_relative "../../../lib/sc-test-core/utils/hash_extension"
module SC
  module Validations
    module ProcValidations
      include SC::Constants::HttpStatusCodes

      #requirement_params {:fsn => fsn, :sku => sku and any other param}
      def requirement_exists(requirement_params)
        requirement_params[:status] = "created" if requirement_params[:status].nil?
        puts "Validating that requirement with params #{requirement_params} exists"
        get_req_resp = get_requirements()
        get_req_resp_json = JSON(get_req_resp.to_s)#Need to see why response is coming as string

        total = get_req_resp_json["total"]
        assert(total > 0, "Get Requirements returned 0 Requirements.")

        requirements_json = get_req_resp_json["requirement_groups"][0]["requirements"]

        requirements_json.each do |requirement_json|
          return requirement_json["id"] if requirement_json.has_json?(JSON(requirement_params.to_json))
        end

        assert_true(false, "No requirement found with params #{requirement_params}")
      end

      #po_item_params = {:fsn => fsn, :sku=> sku and any other param}
      def po_item_exists(po_item_params)
        puts "Validating that po item with params #{po_item_params} exists"
        po_item_params[:status] = "created" if po_item_params[:status].nil?
        po_item_params[:cancel_quantity] = 0 if po_item_params[:cancel_quantity].nil?

        search_po_items_resp = search_purchase_order_items()
        search_po_items_resp_json = JSON(search_po_items_resp.to_s)#Need to see why response is coming as string

        total = search_po_items_resp_json["total"]
        assert(total > 0, "Search PO Items returned 0")

        po_items_json = search_po_items_resp_json["purchase_order_items"]

        po_items_json.each do |po_item_json|
          return po_item_json["purchase_order_id"],po_item_json["id"]  if po_item_json.has_json?(JSON(po_item_params.to_json))
        end

        assert_true(false, "No po_item found with params #{po_item_params}")
      end

      #check po params
      def validate_po(po_id,  po_params)
        puts "Validating that po #{po_id} has attributes #{po_params}"
        response = get_purchase_orders!([po_id])
        response_json = JSON(response.body)
        po_json = response_json["purchase_orders"][0]
        assert_true(po_json.has_json?(JSON(po_params.to_json)),"Purchase order #{po_id} with observed info #{po_json} doesn't have params #{po_params}'")
      end

      #I check via po_items
      def validate_po_item(po_id, po_item_id,  po_item_params)
        puts "Validating that po_item #{po_item_id} has attributes #{po_item_params}"
        response = get_purchase_order_item!(po_id, po_item_id)
        response_json = JSON(response.body)
        assert_true(response_json.has_json?(JSON(po_item_params.to_json)),
                    "Purchase order item #{po_item_id} with observed info #{response_json} doesn't have params #{po_params}'")
      end

    end
  end
end