require 'pp'

AdminApp.controllers do
  # with this url structure we should be able to support multiple named loggers in the future
  get '/config/loggers/padrino' do
    {:padrino => Padrino::Logger::Levels.key(Padrino.logger.level)}.to_json
  end

  post 'config/loggers/padrino' do
    return [400, "level not specified"] unless params[:level]
    level = params[:level].to_sym

    return [400, "invalid log level #{level}"] unless Padrino::Logger::Levels[level]

    # update the config so that threads can use the updated log-level
    config = Padrino::Logger::Config[PADRINO_ENV.to_sym]
    if config
      config[:log_level] = level
      return "updated log level to #{level}"
    else
      return [400, "log config for #{PADRINO_ENV} not found"]
    end
  end
end
