require 'active_record'

module Rack
  # Releases ActiveRecord connections checked out by the current thread.
  class ConnectionRelease
    def initialize(app)
      @app = app
    end

    def call(env)
      @app.call(env)
    ensure
      ActiveRecord::Base.connection_handler.clear_active_connections!
    end
  end
end