module SC
  module Warehouse
    module StorageLocations
      module FA
        def inward_fa_location
          Hashie::Mash.new({
                               :area => "forward_area",
                               :location_type => "inward_fa",
                               :capacity => 20,
                               :label => "inward_fa",
                           })
        end

        def shelf_cap_5
          Hashie::Mash.new({
                               :location_type => "forward_area",
                               :label => "shelf_cap_5",
                               :capacity => 5,
                           })
        end

        def shelf_cap_10
          Hashie::Mash.new({
                               :location_type => "forward_area",
                               :label => "shelf_cap_10",
                               :capacity => 10,
                           })
        end

        def shelf_cap_20
          Hashie::Mash.new({
                               :location_type => "forward_area",
                               :label => "shelf_cap_20",
                               :capacity => 20,
                           })
        end

        def shelf2_cap_20
          Hashie::Mash.new({
                               :location_type => "forward_area",
                               :label => "shelf2_cap_20",
                               :capacity => 20,
                           })
        end

        def shelf3_cap_20
          Hashie::Mash.new({
                               :location_type => "forward_area",
                               :label => "shelf3_cap_20",
                               :capacity => 20,
                           })
        end

        def shelf1_cap_40
          Hashie::Mash.new({
                               :location_type => "forward_area",
                               :label => "shelf1_cap_40",
                               :capacity => 40,
                           })
        end

        def shelf2_cap_40
          Hashie::Mash.new({
                               :location_type => "forward_area",
                               :label => "shelf2_cap_40",
                               :capacity => 40,
                           })
        end

        def shelf3_cap_40
          Hashie::Mash.new({
                               :location_type => "forward_area",
                               :label => "shelf3_cap_40",
                               :capacity => 40,
                           })
        end

        def fa_locations
          all_locations = self.methods.collect do |method|
            self.send(method) if ((method.to_s.start_with?("shelf") or method.to_s.start_with?("inward")) and (method != :fa_locations))
          end
          all_locations.delete(nil)
          all_locations
        end
      end

      module Store
        def inward_bulk
          Hashie::Mash.new({
                               :area => "store",
                               :location_type => "inward_bulk",
                               :capacity => 20,
                               :label => "inward_bulk",
                           })
        end

        def store_location1
          Hashie::Mash.new({
                               :location_type => "store",
                               :label => "st-1001",
                               :capacity => 20,
                           })
        end

        def store_location2
          Hashie::Mash.new({
                               :location_type => "store",
                               :label => "st-1002",
                               :capacity => 20,
                           })
        end

        def store_location3
          Hashie::Mash.new({
                               :location_type => "store",
                               :label => "st-1003",
                               :capacity => 20,
                           })
        end

        def store_location4
          Hashie::Mash.new({
                               :location_type => "store",
                               :label => "st-1004",
                               :capacity => 20,
                           })
        end

        def store_locations
          all_locations = self.methods.collect do |method|
            self.send(method) if ((method.to_s.start_with?("shelf") or method.to_s.start_with?("inward")) and (method != :store_locations))
          end
          all_locations.delete(nil)
          all_locations
        end
      end

    end
  end
end


