require "rest-client"

module  ScLibrary

  class RestClientWrapper

    attr_reader :base_url

    def initialize(base_url)
      @baser_url=base_url
    end

    def get(url_resource, headers={:content_type => :json}, &params_block)
      url = append url_resource
      params_block = Proc.new do |response,request,result| response end unless params_block
      RestClient.get url, headers, &params_block
    end

    def post(url_resource,payload, headers={}, &params_block)
      url = append url_resource
      params_block = Proc.new do |response,request,result| response end unless params_block
      RestClient.post url,payload,headers,&params_block
    end

    def put(url_resource,payload, headers={}, &params_block)
      url = append url_resource
      params_block = Proc.new do |response,request,result| response end unless params_block
      RestClient.put url,payload,headers,&params_block
    end

    def delete(url_resource, headers={}, &params_block)
      url = append url_resource
      params_block = Proc.new do |response,request,result| response end unless params_block
      RestClient.delete url,headers,&params_block
    end

    def get_json(url_resource,headers={:content_type => :json})
      self.get url_resource, headers do |response,request,result| response end
    end

    def post_json(url_resource,payload, headers={:content_type => :json})
      self.post url_resource, payload.to_json, headers do |response,request,result| response end
    end

    def put_json(url_resource,payload, headers={:content_type => :json})
      self.put url_resource, payload.to_json, headers do |response,request,result| response end
    end

    def delete_json(url_resource, headers={:content_type => :json}, &params_block)
      self.delete url_resource,headers,&params_block
    end

    private
    def append(url_resource)
      @baser_url + url_resource
    end

  end

end
